##############################
### ROZDZIAL 4 ###############
##############################
### Model Heckmana ###########
##############################
### (C) Aneta Biernat ########
##############################

setwd("C:/Andrzej/OneDrive - SGH/Dydaktyka/ksiazka_kolo/zastosowania_ekonometrii_www/04") 

install.packages("maxLik", "miscTools", "sampleSelection", "mvtnorm", "Hmisc")
library("maxLik")
library("miscTools")
library("sampleSelection")
library("mvtnorm")
library("Hmisc")

# Load data from text file

Heckman_data <- read.csv("rozdzial_4.txt", sep = ";")
attach(Heckman_data)

# Correlations with significance levels


#rcorr(x, type="pearson") # type can be pearson or spearman
#mtcars is a data frame 
#rcorr(as.matrix(Heckman_data))

# Models 

Hmodel <- heckit(div_exist ~ factor(year) + factor(industry) + ROA + log(size) + asset_growth + market_to_book,
                 div_yield ~ factor(year) + factor(industry) + market_to_book + leverage + FCF, data = Heckman_data)
summary(Hmodel)

Selmodel <- selection(div_exist ~ factor(year) + factor(industry) + ROA + log(size) + asset_growth + market_to_book,
                 div_yield ~ factor(year) + factor(industry) +  market_to_book + leverage + FCF, data = Heckman_data)

summary(Selmodel)

#OLSmodel <- lm(div_yield ~ factor(year) + factor(industry) + market_to_book + leverage + FCF, data=Heckman_data)
#summary(OLSmodel)


detach(Heckman_data)

# Extract all coefficients of the model

coef(Hmodel)

## Extract the coefficients of the outcome model only

coef(Hmodel, part = "outcome")

## Extract all coefficients, standard errors, t-values, and p-values of the model

coef(summary(Hmodel))

coef(summary(Hmodel), part = "outcome")


